Microsoft MVP성태의 닷넷 이야기
글쓴 사람
정성태 (techsharer at outlook.com)
홈페이지
첨부 파일
 

파이썬 - <class 'AttributeError'> module 'flask.json' has no attribute 'JSONEncoder'

개인적으로, 파이썬의 패키지 관리가 좀 마음에 들지 않습니다. ^^; 파이썬 경력이 얼마 없지만, 그사이 이상한 충돌 현상을 겪은 것이 서너 번 정도 되는 것 같습니다.

예를 들어, WSL + Ubuntu 20.04가 설치된 환경에서 python 3.8.10을 설치 후 Flask와, Flask-Migrate를 설치하면,

$ python3 -m pip install Flask==2.2.2
$ python3 -m pip install Flask-Migrate==3.1.0

지정한 버전 그대로 설치가 됩니다. 그런데, container 이미지인 "python:3.8-slim-buster"로 구성한 환경(파이썬 버전 3.8.12)에서 위의 설치 명령을 실행하면, Flask-Migrate 설치 과정에서 아래와 같이 Flask를 2.3.2 버전으로 업데이트를 해버립니다.

# python3 -m pip install Flask==2.2.2
# pip install Flask-Migrate==3.1.0
Requirement already satisfied: Flask-Migrate==3.1.0 in /usr/local/lib/python3.8/site-packages (3.1.0)
Requirement already satisfied: Flask>=0.9 in /usr/local/lib/python3.8/site-packages (from Flask-Migrate==3.1.0) (2.2.2)
...[생략]...
Installing collected packages: Flask
  Attempting uninstall: Flask
    Found existing installation: Flask 2.2.2
    Uninstalling Flask-2.2.2:
      Successfully uninstalled Flask-2.2.2
Successfully installed Flask-2.3.2

출력을 보면, 분명히 "Requirement already satisfied: Flask>=0.9"라고 해서 조건을 만족하는 것으로 나오는데 새롭게 2.3.2 버전을 설치하고 있습니다. 여기서 문제는, 위와 같은 조건의 환경에서 Flask App을 실행하면 이런 예외가 발생하면서 Flask 환경 구성에 실패한다는 점입니다.

Traceback (most recent call last):,
  File "./wsgi.py", line 4, in <module>,
    application = pybo.create_app(),
  File "/app/build_root/flask_sample/./pybo/__init__.py", line 45, in create_app,
    from .views import main_views, question_views, answer_views, auth_views,
  File "/app/build_root/flask_sample/./pybo/views/question_views.py", line 3, in <module>,
    from ..forms import QuestionForm, AnswerForm,
  File "/app/build_root/flask_sample/./pybo/forms.py", line 1, in <module>,
    from flask_wtf import FlaskForm,
  File "/usr/local/lib/python3.8/site-packages/flask_wtf/__init__.py", line 4, in <module>,
    from .recaptcha import Recaptcha,
  File "/usr/local/lib/python3.8/site-packages/flask_wtf/recaptcha/__init__.py", line 1, in <module>,
    from .fields import RecaptchaField,
  File "/usr/local/lib/python3.8/site-packages/flask_wtf/recaptcha/fields.py", line 3, in <module>,
    from . import widgets,
  File "/usr/local/lib/python3.8/site-packages/flask_wtf/recaptcha/widgets.py", line 6, in <module>,
    JSONEncoder = json.JSONEncoder,
AttributeError: module 'flask.json' has no attribute 'JSONEncoder',

해결 방법은, 설치 순서를 바꾸면 됩니다. ^^;

# python:3.8-slim-buster 환경에서, 아래는 Flask 2.3.2 버전을 설치하고,
pip install Flask-Migrate==3.1.0

# 위에서 설치한 2.3.2를 제거하고 2.2.2로 새롭게 설치
pip install Flask==2.2.2




관련해서 검색해 보면,

Flask AttributeError: module 'flask.json' has no attribute 'JSONEncoder'
; https://stackoverflow.com/questions/76107450/flask-attributeerror-module-flask-json-has-no-attribute-jsonencoder/76325779#76325779

이 문제가 Flask-WTF 모듈과도 연관이 있다고 나옵니다. 따라서 만약 Flask-Migrate가 원하는 대로 2.3.2 버전의 Flask 업데이트 상황에서도 정상적으로 사용하고 싶다면 Flask-WTF 모듈을 1.1.1 버전 이상으로 업데이트하면 됩니다.

# python:3.8-slim-buster 환경에서, 아래는 Flask 2.2.2 버전을 설치하지만,
pip install Flask==2.2.2

# 아래의 명령으로 인해 Flask 2.3.2 버전이 설치되고,
pip install Flask-Migrate==3.1.0

# Flask-WTF 버전을 1.1.1 이상으로 올림으로써 AttributeError 예외가 나지 않도록 구성
pip install Flask-WTF==1.1.1




[이 글에 대해서 여러분들과 의견을 공유하고 싶습니다. 틀리거나 미흡한 부분 또는 의문 사항이 있으시면 언제든 댓글 남겨주십시오.]







[최초 등록일: ]
[최종 수정일: 6/20/2023]

Creative Commons License
이 저작물은 크리에이티브 커먼즈 코리아 저작자표시-비영리-변경금지 2.0 대한민국 라이센스에 따라 이용하실 수 있습니다.
by SeongTae Jeong, mailto:techsharer at outlook.com

비밀번호

댓글 작성자
 




1  2  3  [4]  5  6  7  8  9  10  11  12  13  14  15  ...
NoWriterDateCnt.TitleFile(s)
13490정성태12/19/20231392개발 환경 구성: 698. Golang - GLIBC 의존을 없애는 정적 빌드 방법
13489정성태12/19/20231180개발 환경 구성: 697. GoLand에서 ldflags 지정 방법
13488정성태12/18/20231187오류 유형: 884. HTTP 500.0 - 명령행에서 실행한 ASP.NET Core 응용 프로그램을 실행하는 방법
13487정성태12/16/20231399개발 환경 구성: 696. C# - 리눅스용 AOT 빌드를 docker에서 수행 [1]
13486정성태12/15/20231223개발 환경 구성: 695. Nuget config 파일에 값 설정/삭제 방법
13485정성태12/15/20231224오류 유형: 883. dotnet build/restore - error : Root element is missing
13484정성태12/14/20231344개발 환경 구성: 694. Windows 디렉터리 경로를 WSL의 /mnt 포맷으로 구하는 방법
13483정성태12/14/20231504닷넷: 2184. C# - 하나의 resource 파일을 여러 프로그램에서 (AOT 시에도) 사용하는 방법파일 다운로드1
13482정성태12/13/20231847닷넷: 2183. C# - eFriend Expert OCX 예제를 .NET Core/5+ Console App에서 사용하는 방법 [2]파일 다운로드1
13481정성태12/13/20231551개발 환경 구성: 693. msbuild - .NET Core/5+ 프로젝트에서 resgen을 이용한 리소스 파일 생성 방법파일 다운로드1
13480정성태12/12/20231583개발 환경 구성: 692. Windows WSL 2 + Chrome 웹 브라우저 설치
13479정성태12/11/20231567개발 환경 구성: 691. WSL 2 (Ubuntu) + nginx 환경 설정
13477정성태12/8/20231724닷넷: 2182. C# - .NET 7부터 추가된 Int128, UInt128 [1]파일 다운로드1
13476정성태12/8/20231542닷넷: 2181. C# - .NET 8 JsonStringEnumConverter의 AOT를 위한 개선파일 다운로드1
13475정성태12/7/20231566닷넷: 2180. .NET 8 - 함수 포인터에 대한 Reflection 정보 조회파일 다운로드1
13474정성태12/6/20231470개발 환경 구성: 690. 닷넷 코어/5+ 버전의 ilasm/ildasm 실행 파일 구하는 방법 - 두 번째 이야기
13473정성태12/5/20231580닷넷: 2179. C# - 값 형식(Blittable)을 메모리 복사를 이용해 바이트 배열로 직렬화/역직렬화파일 다운로드1
13472정성태12/4/20231452C/C++: 164. Visual C++ - InterlockedCompareExchange128 사용 방법
13471정성태12/4/20231501Copilot - To enable GitHub Copilot, authorize this extension using GitHub's device flow
13470정성태12/2/20231702닷넷: 2178. C# - .NET 8부터 COM Interop에 대한 자동 소스 코드 생성 도입파일 다운로드1
13469정성태12/1/20231536닷넷: 2177. C# - (Interop DLL 없이) CoClass를 이용한 COM 개체 생성 방법파일 다운로드1
13468정성태12/1/20231474닷넷: 2176. C# - .NET Core/5+부터 달라진 RCW(Runtime Callable Wrapper) 대응 방식파일 다운로드1
13467정성태11/30/20231498오류 유형: 882. C# - Unhandled exception. System.Runtime.InteropServices.COMException (0x800080A5)파일 다운로드1
13466정성태11/29/20231630닷넷: 2175. C# - DllImport 메서드의 AOT 지원을 위한 LibraryImport 옵션
13465정성태11/28/20231457개발 환경 구성: 689. MSBuild - CopyToOutputDirectory가 "dotnet publish" 시에는 적용되지 않는 문제파일 다운로드1
13464정성태11/28/20231594닷넷: 2174. C# - .NET 7부터 UnmanagedCallersOnly 함수 export 기능을 AOT 빌드에 통합파일 다운로드1
1  2  3  [4]  5  6  7  8  9  10  11  12  13  14  15  ...